﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.Windows.Data;
using System.ComponentModel;
using System.Threading;


namespace XamGridValidation
{
    public partial class MainPage : UserControl
    {
        List<TestINotifyDataErrorInfo> _boundData = new List<TestINotifyDataErrorInfo>();
        public List<TestINotifyDataErrorInfo> BoundData
        {
            get { return _boundData; }
            set { _boundData = value; }
        }

        public MainPage()
        {
            for (int i = 0; i < 30; i++)
                BoundData.Add(new TestINotifyDataErrorInfo());

            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            igGrid.ItemsSource = BoundData;
        }

        private void AddError_Click(object sender, RoutedEventArgs e)
        {

            this.BoundData[0].SetError("IntegerData", "Blah blah");
            //this.BoundData[0].SetError("BoolData", "Blah blah");
            //this.BoundData[0].SetError("DateTimeData", "Blah blah");
            
        }

        private void ClearErrors_Click(object sender, RoutedEventArgs e)
        {
            this.BoundData[0].ClearDataErrorInfo("IntegerData");
            //this.BoundData[0].ClearDataErrorInfo("DateTimeData");
            //this.BoundData[0].ClearDataErrorInfo("BoolData");

        }

    }


    public class IntConverter : IValueConverter
    {
        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            var smth = value as TestDataBase;
            if (smth != null)
                return smth.StringData + smth.IntegerData.ToString();
            else
                return "Error during conversion";
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }

    public class EnumToBoolConverter : IValueConverter
    {

        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null || parameter == null)
                return value;

            return value.ToString() == parameter.ToString();
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value == null || parameter == null)
                return value;

            return Enum.Parse(targetType, (String)parameter, true);
        }

        #endregion
    }

    public struct CustomBindingSpecifics
    {
        public bool ValidatesOnDataErrors { get; set; }

        public bool ValidatesOnNotifyDataError { get; set; }

        public bool NotifyOnValidationError { get; set; }

        public BindingMode Mode { get; set; }



        public override string ToString()
        {
            return string.Format(@"ValidatesOnDataErrors: {0}
                                   ValidatesOnNotifyDataError: {1}
                                   NotifyOnValidationError: {2}
                                   Mode: {3}",
                                   ValidatesOnDataErrors.ToString(),
                                   ValidatesOnNotifyDataError.ToString(),
                                   NotifyOnValidationError.ToString(),
                                   Mode.ToString());
        }
    }
    public enum DataBoundType
    {
        ImplementIDataErrorInfoInterface,
        ImplementINotifyDataErrorInfoInterface,
        Both,
        None
    }
}
